// uint
typedef unsigned int uint;

// Spielsituation
struct GameState
{
    const char* p_name[2];  // Namen der Spieler
    uint score[2];          // Punktzahlen
    uint time;              // Zeit
    float player_y[2];      // y-Positionen der Spieler
    float player_vy[2];     // y-Geschwindigkeiten der Spieler
    float ball_x;           // x-Position des Balls
    float ball_y;           // y-Position des Balls
    float ball_vx;          // x-Geschwindigkeit des Balls
    float ball_vy;          // y-Geschwindigkeit des Balls
};

// Funktionszeigertyp
typedef int (* PongFunctionPtr)(const GameState&, uint);

// Breite des Spielfelds
extern const float FIELD_WIDTH;

// Hhe des Spielfelds
extern const float FIELD_HEIGHT;

// Lnge der Schlger
extern const float PADDLE_SIZE;

// Beschleunigung des Spielers
extern const float PLAYER_ACCELERATION;

// Dmpfung der Spielergeschwindigkeit
extern const float PLAYER_DAMPING;

// Startgeschwindigkeit des Balls
extern const float START_BALL_SPEED;

// Erhhung der Ballgeschwindigkeit mit jedem Schlag (Faktor)
extern const float BALL_SPEED_INCREASE;

// Teilnehmer
struct Entry
{
    Entry() { }

    Entry(const char* p_name,
          PongFunctionPtr function)
        : p_name(p_name)
        , function(function)
        , points(0)
        , wins(0)
        , losses(0)
        , goals_made(0)
        , goals_got(0)
    {
    }

    const char* p_name;
    PongFunctionPtr function;
    uint points;
    uint wins;
    uint losses;
    uint goals_made;
    uint goals_got;
};

// Visualisierung starten
void visualizer_start();

// Spielzustand visualisieren
void visualizer_update(const GameState& gs);

// Visualisierung beenden
void visualizer_end();
